Index: squid/src/store.c
diff -u squid/src/store.c:1.10 squid/src/store.c:1.2.2.21
--- squid/src/store.c:1.10	Thu Feb 22 21:51:08 2001
+++ squid/src/store.c	Sun Mar 18 14:33:32 2001
@@ -77,23 +77,20 @@
  * local function prototypes
  */
 static int storeEntryValidLength(const StoreEntry *);
+#if 0
 static void storeGetMemSpace(int);
-static void storeHashDelete(StoreEntry *);
+#endif
 static MemObject *new_MemObject(const char *, const char *);
 static void destroy_MemObject(StoreEntry *);
 static FREE destroy_StoreEntry;
+#if 0
 static void storePurgeMem(StoreEntry *);
-static void storeEntryReferenced(StoreEntry *);
-static void storeEntryDereferenced(StoreEntry *);
-static int getKeyCounter(void);
-static int storeKeepInMemory(const StoreEntry *);
+#endif
 static OBJH storeCheckCachableStats;
-static EVH storeLateRelease;
 
 /*
  * local variables
  */
-static Stack LateReleaseStack;
 
 #if URL_CHECKSUM_DEBUG
 unsigned int
@@ -132,8 +129,8 @@
 {
     StoreEntry *e = NULL;
     e = memAllocate(MEM_STOREENTRY);
-    if (mem_obj_flag)
-	e->mem_obj = new_MemObject(url, log_url);
+    /* We're always creating MemObjects now! */
+    e->mem_obj = new_MemObject(url, log_url);
     debug(20, 3) ("new_StoreEntry: returning %p\n", e);
     e->expires = e->lastmod = e->lastref = e->timestamp = -1;
     e->swap_filen = -1;
@@ -150,16 +147,15 @@
 #if URL_CHECKSUM_DEBUG
     assert(mem->chksum == url_checksum(mem->url));
 #endif
+    
+
     e->mem_obj = NULL;
-    if (!shutting_down)
-	assert(mem->swapout.sio == NULL);
-    stmemFree(&mem->data_hdr);
-    mem->inmem_hi = 0;
+
     /*
      * There is no way to abort FD-less clients, so they might
      * still have mem->clients set if mem->fd == -1
      */
-    assert(mem->fd == -1 || mem->clients.head == NULL);
+    assert(mem->fd == -1 || e->sc.valid == 0);
     httpReplyDestroy(mem->reply);
     requestUnlink(mem->request);
     mem->request = NULL;
@@ -175,102 +171,55 @@
     StoreEntry *e = data;
     debug(20, 3) ("destroy_StoreEntry: destroying %p\n", e);
     assert(e != NULL);
-    if (e->mem_obj)
-	destroy_MemObject(e);
-    storeHashDelete(e);
-    assert(e->hash.key == NULL);
-    memFree(e, MEM_STOREENTRY);
-}
+    assert(e->mem_obj != NULL);
 
-/* ----- INTERFACE BETWEEN STORAGE MANAGER AND HASH TABLE FUNCTIONS --------- */
+    dlinkDelete(&e->node, &store_list);
 
-void
-storeHashInsert(StoreEntry * e, const cache_key * key)
-{
-    debug(20, 3) ("storeHashInsert: Inserting Entry %p key '%s'\n",
-	e, storeKeyText(key));
-    e->hash.key = storeKeyDup(key);
-    hash_join(store_table, &e->hash);
-}
+    /* Free the reply .. */
+    storeDetachReply(e);
 
-static void
-storeHashDelete(StoreEntry * e)
-{
-    hash_remove_link(store_table, &e->hash);
-    storeKeyFree(e->hash.key);
-    e->hash.key = NULL;
+    /* Scrape it clean .. */
+    destroy_MemObject(e);
+
+    memFree(e, MEM_STOREENTRY);
 }
 
 /* -------------------------------------------------------------------------- */
 
 
+#if 0
 /* get rid of memory copy of the object */
 /* Only call this if storeCheckPurgeMem(e) returns 1 */
 static void
 storePurgeMem(StoreEntry * e)
 {
-    if (e->mem_obj == NULL)
-	return;
+    assert(e->mem_obj != NULL);
     debug(20, 3) ("storePurgeMem: Freeing memory-copy of %s\n",
-	storeKeyText(e->hash.key));
-    storeSetMemStatus(e, NOT_IN_MEMORY);
+	storeKeyUrl(e));
     destroy_MemObject(e);
     if (e->swap_status != SWAPOUT_DONE)
 	storeRelease(e);
 }
+#endif
 
-static void
-storeEntryReferenced(StoreEntry * e)
-{
-    SwapDir *SD;
-
-    /* Notify the fs that we're referencing this object again */
-    if (e->swap_dirn > -1) {
-	SD = INDEXSD(e->swap_dirn);
-	if (SD->refobj)
-	    SD->refobj(SD, e);
-    }
-    /* Notify the memory cache that we're referencing this object again */
-    if (e->mem_obj) {
-	if (mem_policy->Referenced)
-	    mem_policy->Referenced(mem_policy, e, &e->mem_obj->repl);
-    }
-}
-
-static void
-storeEntryDereferenced(StoreEntry * e)
-{
-    SwapDir *SD;
-
-    /* Notify the fs that we're not referencing this object any more */
-    if (e->swap_filen > -1) {
-	SD = INDEXSD(e->swap_dirn);
-	if (SD->unrefobj != NULL)
-	    SD->unrefobj(SD, e);
-    }
-    /* Notify the memory cache that we're not referencing this object any more */
-    if (e->mem_obj) {
-	if (mem_policy->Dereferenced)
-	    mem_policy->Dereferenced(mem_policy, e, &e->mem_obj->repl);
-    }
-}
 
 void
 storeLockObject(StoreEntry * e)
 {
+    assert(e->mem_obj != NULL);
     e->lock_count++;
     debug(20, 3) ("storeLockObject: key '%s' count=%d\n",
-	storeKeyText(e->hash.key), (int) e->lock_count);
+	storeKeyUrl(e), (int) e->lock_count);
     e->lastref = squid_curtime;
-    storeEntryReferenced(e);
 }
 
 void
 storeReleaseRequest(StoreEntry * e)
 {
+    assert(e->mem_obj != NULL);
     if (EBIT_TEST(e->flags, RELEASE_REQUEST))
 	return;
-    debug(20, 3) ("storeReleaseRequest: '%s'\n", storeKeyText(e->hash.key));
+    debug(20, 3) ("storeReleaseRequest: '%s'\n", storeKeyUrl(e));
     EBIT_SET(e->flags, RELEASE_REQUEST);
     /*
      * Clear cachable flag here because we might get called before
@@ -278,6 +227,15 @@
      * prevents httpMakePublic from really setting a public key.
      */
     EBIT_CLR(e->flags, ENTRY_CACHABLE);
+    /*
+     * Notify the reply layer that we want this object released..
+     * XXX an evil hack - this can be called before the reply object
+     * is attached. If this happens, don't try to notify the reply
+     * object. When the reply object is created by createNewStoreEntry
+     * we'll be ok. -- adrian
+     */
+    if (e->strelease != NULL)
+        e->strelease(e);
     storeSetPrivateKey(e);
 }
 
@@ -286,28 +244,30 @@
 int
 storeUnlockObject(StoreEntry * e)
 {
+    assert(e->mem_obj != NULL);
     e->lock_count--;
     debug(20, 3) ("storeUnlockObject: key '%s' count=%d\n",
-	storeKeyText(e->hash.key), e->lock_count);
+	storeKeyUrl(e), e->lock_count);
     if (e->lock_count)
 	return (int) e->lock_count;
-    if (e->store_status == STORE_PENDING)
+
+    /* If the object is still pending data, we set RELEASE_REQUEST and wait */
+    if (e->store_status == STORE_PENDING) {
 	EBIT_SET(e->flags, RELEASE_REQUEST);
+        return 0;
+    }
+
+    /* The object is not pending data, so kill it .. */
     assert(storePendingNClients(e) == 0);
+    assert(e->store_status == STORE_OK);
+
+    /* Only release an object if we've been requested to.. */
     if (EBIT_TEST(e->flags, RELEASE_REQUEST))
-	storeRelease(e);
-    else if (storeKeepInMemory(e)) {
-	storeEntryDereferenced(e);
-	storeSetMemStatus(e, IN_MEMORY);
-	requestUnlink(e->mem_obj->request);
-	e->mem_obj->request = NULL;
-    } else {
-	storePurgeMem(e);
-	storeEntryDereferenced(e);
-	if (EBIT_TEST(e->flags, KEY_PRIVATE))
-	    debug(20, 1) ("WARNING: %s:%d: found KEY_PRIVATE\n", __FILE__, __LINE__);
-    }
-    return 0;
+        storeRelease(e);
+    else
+        destroy_StoreEntry(e);
+
+    return -1;
 }
 
 /* Lookup an object in the cache.
@@ -316,7 +276,12 @@
 storeGet(const cache_key * key)
 {
     debug(20, 3) ("storeGet: looking up %s\n", storeKeyText(key));
+    return NULL;
+
+    /* XXX we will perform a FS lookup here .. */
+#if 0
     return (StoreEntry *) hash_lookup(store_table, key);
+#endif
 }
 
 StoreEntry *
@@ -325,43 +290,23 @@
     return storeGet(storeKeyPublic(uri, method));
 }
 
-static int
-getKeyCounter(void)
-{
-    static int key_counter = 0;
-    if (++key_counter < 0)
-	key_counter = 1;
-    return key_counter;
-}
-
 void
 storeSetPrivateKey(StoreEntry * e)
 {
-    const cache_key *newkey;
-    MemObject *mem = e->mem_obj;
-    if (e->hash.key && EBIT_TEST(e->flags, KEY_PRIVATE))
+    if (EBIT_TEST(e->flags, KEY_PRIVATE))
 	return;			/* is already private */
-    if (e->hash.key) {
-	if (e->swap_filen > -1)
-	    storeDirSwapLog(e, SWAP_LOG_DEL);
-	storeHashDelete(e);
-    }
-    if (mem != NULL) {
-	mem->id = getKeyCounter();
-	newkey = storeKeyPrivate(mem->url, mem->method, mem->id);
-    } else {
-	newkey = storeKeyPrivate("JUNK", METHOD_NONE, getKeyCounter());
-    }
-    assert(hash_lookup(store_table, newkey) == NULL);
     EBIT_SET(e->flags, KEY_PRIVATE);
-    storeHashInsert(e, newkey);
+    /* XXX this lame check can go !!! -- adrian */
+    if (e->stmakeprivate)
+        e->stmakeprivate(e);
 }
 
 void
 storeSetPublicKey(StoreEntry * e)
 {
+#if 0
     StoreEntry *e2 = NULL;
-    const cache_key *newkey;
+#endif
     MemObject *mem = e->mem_obj;
     if (e->hash.key && !EBIT_TEST(e->flags, KEY_PRIVATE))
 	return;			/* is already public */
@@ -382,7 +327,12 @@
 	    e->hash.key, mem->url);
 #endif
     assert(!EBIT_TEST(e->flags, RELEASE_REQUEST));
-    newkey = storeKeyPublic(mem->url, mem->method);
+#if 0
+    /*
+     * We don't need this anymore, key collisions should be handled in
+     * the object store(s)
+     *   -- adrian
+     */
     if ((e2 = (StoreEntry *) hash_lookup(store_table, newkey))) {
 	debug(20, 3) ("storeSetPublicKey: Making old '%s' private.\n", mem->url);
 	storeSetPrivateKey(e2);
@@ -391,14 +341,18 @@
     }
     if (e->hash.key)
 	storeHashDelete(e);
+#endif
     EBIT_CLR(e->flags, KEY_PRIVATE);
-    storeHashInsert(e, newkey);
+    /* XXX this lame check can go !!! -- adrian */
+    if (e->stmakepublic)
+        e->stmakepublic(e);
     if (e->swap_filen > -1)
 	storeDirSwapLog(e, SWAP_LOG_ADD);
 }
 
 StoreEntry *
-storeCreateEntry(const char *url, const char *log_url, request_flags flags, method_t method)
+storeCreateEntry(const char *url, const char *log_url, request_flags flags,
+  method_t method, reply_obj_t reply_obj)
 {
     StoreEntry *e = NULL;
     MemObject *mem = NULL;
@@ -408,6 +362,20 @@
     e->lock_count = 1;		/* Note lock here w/o calling storeLock() */
     mem = e->mem_obj;
     mem->method = method;
+    dlinkAdd(e, &e->node, &store_list);
+
+    switch (reply_obj) {
+      case REPLY_OBJ_INTERNAL:
+        reply_internal_create(e);
+        break;
+      case REPLY_OBJ_NETWORK:
+        reply_network_create(e);
+        break;
+      default:
+        fatal("No valid reply_obj given to storeCreateEntry!\n");
+        /* NOTREACHED */
+    } 
+
     if (neighbors_do_private_keys || !flags.hierarchical)
 	storeSetPrivateKey(e);
     else
@@ -419,8 +387,8 @@
 	EBIT_CLR(e->flags, ENTRY_CACHABLE);
 	storeReleaseRequest(e);
     }
+
     e->store_status = STORE_PENDING;
-    storeSetMemStatus(e, NOT_IN_MEMORY);
     e->swap_status = SWAPOUT_NONE;
     e->swap_filen = -1;
     e->swap_dirn = -1;
@@ -428,7 +396,6 @@
     e->lastref = squid_curtime;
     e->timestamp = -1;		/* set in storeTimestampsSet() */
     e->ping_status = PING_NONE;
-    EBIT_SET(e->flags, ENTRY_VALIDATED);
     return e;
 }
 
@@ -436,7 +403,7 @@
 void
 storeExpireNow(StoreEntry * e)
 {
-    debug(20, 3) ("storeExpireNow: '%s'\n", storeKeyText(e->hash.key));
+    debug(20, 3) ("storeExpireNow: '%s'\n", storeKeyUrl(e));
     e->expires = squid_curtime;
 }
 
@@ -444,22 +411,7 @@
 void
 storeAppend(StoreEntry * e, const char *buf, int len)
 {
-    MemObject *mem = e->mem_obj;
-    assert(mem != NULL);
-    assert(len >= 0);
-    assert(e->store_status == STORE_PENDING);
-    if (len) {
-	debug(20, 5) ("storeAppend: appending %d bytes for '%s'\n",
-	    len,
-	    storeKeyText(e->hash.key));
-	storeGetMemSpace(len);
-	stmemAppend(&mem->data_hdr, buf, len);
-	mem->inmem_hi += len;
-    }
-    if (EBIT_TEST(e->flags, DELAY_SENDING))
-	return;
-    InvokeHandlers(e);
-    storeSwapOut(e);
+    e->stappend(e, buf, len);
 }
 
 void
@@ -562,7 +514,7 @@
 	return 0;		/* avoid release call below */
     } else if ((e->mem_obj->reply->content_length > 0 &&
 		e->mem_obj->reply->content_length > Config.Store.maxObjectSize) ||
-	e->mem_obj->inmem_hi > Config.Store.maxObjectSize) {
+	storeMemHiOffset(e) > Config.Store.maxObjectSize) {
 	debug(20, 2) ("storeCheckCachable: NO: too big\n");
 	store_check_cachable_hist.no.too_big++;
     } else if (e->mem_obj->reply->content_length > (int) Config.Store.maxObjectSize) {
@@ -629,17 +581,17 @@
 void
 storeComplete(StoreEntry * e)
 {
-    debug(20, 3) ("storeComplete: '%s'\n", storeKeyText(e->hash.key));
+    debug(20, 3) ("storeComplete: '%s'\n", storeKeyUrl(e));
     if (e->store_status != STORE_PENDING) {
 	/*
 	 * if we're not STORE_PENDING, then probably we got aborted
 	 * and there should be NO clients on this entry
 	 */
 	assert(EBIT_TEST(e->flags, ENTRY_ABORTED));
-	assert(e->mem_obj->nclients == 0);
+	assert(e->sc.valid == 0);
 	return;
     }
-    e->mem_obj->object_sz = e->mem_obj->inmem_hi;
+    e->mem_obj->object_sz = storeMemHiOffset(e);
     e->store_status = STORE_OK;
     assert(e->mem_status == NOT_IN_MEMORY);
     if (!storeEntryValidLength(e)) {
@@ -656,7 +608,6 @@
      * responses without content length would sometimes get released
      * in client_side, thinking that the response is incomplete.
      */
-    storeSwapOut(e);
     InvokeHandlers(e);
 }
 
@@ -671,18 +622,17 @@
     MemObject *mem = e->mem_obj;
     assert(e->store_status == STORE_PENDING);
     assert(mem != NULL);
-    debug(20, 6) ("storeAbort: %s\n", storeKeyText(e->hash.key));
+    debug(20, 6) ("storeAbort: %s\n", storeKeyUrl(e));
     storeLockObject(e);		/* lock while aborting */
     storeNegativeCache(e);
     storeReleaseRequest(e);
     EBIT_SET(e->flags, ENTRY_ABORTED);
-    storeSetMemStatus(e, NOT_IN_MEMORY);
     e->store_status = STORE_OK;
     /*
      * We assign an object length here.  The only other place we assign
      * the object length is in storeComplete()
      */
-    mem->object_sz = mem->inmem_hi;
+    mem->object_sz = storeMemHiOffset(e);
     /* Notify the server side */
     if (mem->abort.callback) {
 	eventAdd("mem->abort.callback",
@@ -696,10 +646,11 @@
     /* Notify the client side */
     InvokeHandlers(e);
     /* Close any swapout file */
-    storeSwapOutFileClose(e);
     storeUnlockObject(e);	/* unlock */
 }
 
+/* This function isn't used right now .. -- adrian */
+#if 0
 /* Clear Memory storage to accommodate the given object len */
 static void
 storeGetMemSpace(int size)
@@ -729,10 +680,8 @@
     debug(20, 3) ("  %6d HOT objects\n", hot_obj_count);
     debug(20, 3) ("  %6d were released\n", released);
 }
+#endif
 
-/* The maximum objects to scan for maintain storage space */
-#define MAINTAIN_MAX_SCAN	1024
-#define MAINTAIN_MAX_REMOVE	64
 
 /*
  * This routine is to be called by main loop in main.c.
@@ -774,7 +723,8 @@
 void
 storeRelease(StoreEntry * e)
 {
-    debug(20, 3) ("storeRelease: Releasing: '%s'\n", storeKeyText(e->hash.key));
+    debug(20, 3) ("storeRelease: Releasing: '%s'\n", storeKeyUrl(e));
+
     /* If, for any reason we can't discard this object because of an
      * outstanding request, mark it for pending release */
     if (storeEntryLocked(e)) {
@@ -783,81 +733,24 @@
 	storeReleaseRequest(e);
 	return;
     }
-    if (store_dirs_rebuilding && e->swap_filen > -1) {
-	storeSetPrivateKey(e);
-	if (e->mem_obj) {
-	    storeSetMemStatus(e, NOT_IN_MEMORY);
-	    destroy_MemObject(e);
-	}
-	if (e->swap_filen > -1) {
-	    /*
-	     * Fake a call to storeLockObject().  When rebuilding is done,
-	     * we'll just call storeUnlockObject() on these.
-	     */
-	    e->lock_count++;
-	    EBIT_SET(e->flags, RELEASE_REQUEST);
-	    stackPush(&LateReleaseStack, e);
-	    return;
-	} else {
-	    destroy_StoreEntry(e);
-	}
-    }
+
+    /* Notify the reply layer to release this object */
+    if (!EBIT_TEST(e->flags, RELEASE_REQUEST))
+        e->strelease(e);
+
+    /* Time to deallocate the storeentry .. */
     storeLog(STORE_LOG_RELEASE, e);
-    if (e->swap_filen > -1) {
-	storeUnlink(e);
-	if (e->swap_status == SWAPOUT_DONE)
-	    if (EBIT_TEST(e->flags, ENTRY_VALIDATED))
-		storeDirUpdateSwapSize(&Config.cacheSwap.swapDirs[e->swap_dirn], e->swap_file_sz, -1);
-	if (!EBIT_TEST(e->flags, KEY_PRIVATE))
-	    storeDirSwapLog(e, SWAP_LOG_DEL);
-#if 0
-	/* From 2.4. I think we do this in storeUnlink? */
-	storeSwapFileNumberSet(e, -1);
-#endif
-    }
-    storeSetMemStatus(e, NOT_IN_MEMORY);
+ 
+    /* Here we'd log a swap log delete, but thats done at the FS layer .. */
     destroy_StoreEntry(e);
 }
 
-static void
-storeLateRelease(void *unused)
-{
-    StoreEntry *e;
-    int i;
-    static int n = 0;
-    if (store_dirs_rebuilding) {
-	eventAdd("storeLateRelease", storeLateRelease, NULL, 1.0, 1);
-	return;
-    }
-    for (i = 0; i < 10; i++) {
-	e = stackPop(&LateReleaseStack);
-	if (e == NULL) {
-	    /* done! */
-	    debug(20, 1) ("storeLateRelease: released %d objects\n", n);
-	    return;
-	}
-	storeUnlockObject(e);
-	n++;
-    }
-    eventAdd("storeLateRelease", storeLateRelease, NULL, 0.0, 1);
-}
-
 /* return 1 if a store entry is locked */
 int
 storeEntryLocked(const StoreEntry * e)
 {
     if (e->lock_count)
 	return 1;
-    if (e->swap_status == SWAPOUT_WRITING)
-	return 1;
-    if (e->store_status == STORE_PENDING)
-	return 1;
-    /*
-     * SPECIAL, PUBLIC entries should be "locked"
-     */
-    if (EBIT_TEST(e->flags, ENTRY_SPECIAL))
-	if (!EBIT_TEST(e->flags, KEY_PRIVATE))
-	    return 1;
     return 0;
 }
 
@@ -868,7 +761,7 @@
     const HttpReply *reply;
     assert(e->mem_obj != NULL);
     reply = e->mem_obj->reply;
-    debug(20, 3) ("storeEntryValidLength: Checking '%s'\n", storeKeyText(e->hash.key));
+    debug(20, 3) ("storeEntryValidLength: Checking '%s'\n", storeKeyUrl(e));
     debug(20, 5) ("storeEntryValidLength:     object_len = %d\n",
 	objectLen(e));
     debug(20, 5) ("storeEntryValidLength:         hdr_sz = %d\n",
@@ -877,17 +770,17 @@
 	reply->content_length);
     if (reply->content_length < 0) {
 	debug(20, 5) ("storeEntryValidLength: Unspecified content length: %s\n",
-	    storeKeyText(e->hash.key));
+	    storeKeyUrl(e));
 	return 1;
     }
     if (reply->hdr_sz == 0) {
 	debug(20, 5) ("storeEntryValidLength: Zero header size: %s\n",
-	    storeKeyText(e->hash.key));
+	    storeKeyUrl(e));
 	return 1;
     }
     if (e->mem_obj->method == METHOD_HEAD) {
 	debug(20, 5) ("storeEntryValidLength: HEAD request: %s\n",
-	    storeKeyText(e->hash.key));
+	    storeKeyUrl(e));
 	return 1;
     }
     if (reply->sline.status == HTTP_NOT_MODIFIED)
@@ -900,7 +793,7 @@
     debug(20, 3) ("storeEntryValidLength: %d bytes too %s; '%s'\n",
 	diff < 0 ? -diff : diff,
 	diff < 0 ? "big" : "small",
-	storeKeyText(e->hash.key));
+	storeKeyUrl(e));
     return 0;
 }
 
@@ -925,15 +818,13 @@
 void
 storeInit(void)
 {
+    store_list.head = NULL;
+    store_list.tail = NULL;
     storeKeyInit();
     storeInitHashValues();
-    store_table = hash_create(storeKeyHashCmp,
-	store_hash_buckets, storeKeyHashHash);
     mem_policy = createRemovalPolicy(Config.memPolicy);
     storeDigestInit();
     storeLogOpen();
-    stackInit(&LateReleaseStack);
-    eventAdd("storeLateRelease", storeLateRelease, NULL, 1.0, 1);
     storeDirInit();
     storeRebuildStart();
     cachemgrRegister("storedir",
@@ -957,17 +848,6 @@
     store_pages_max = Config.memMaxSize / SM_PAGE_SIZE;
 }
 
-static int
-storeKeepInMemory(const StoreEntry * e)
-{
-    MemObject *mem = e->mem_obj;
-    if (mem == NULL)
-	return 0;
-    if (mem->data_hdr.head == NULL)
-	return 0;
-    return mem->inmem_lo == 0;
-}
-
 void
 storeNegativeCache(StoreEntry * e)
 {
@@ -978,8 +858,6 @@
 void
 storeFreeMemory(void)
 {
-    hashFreeItems(store_table, destroy_StoreEntry);
-    hashFreeMemory(store_table);
     store_table = NULL;
 #if USE_CACHE_DIGESTS
     if (store_digest)
@@ -1061,23 +939,9 @@
 void
 storeMemObjectDump(MemObject * mem)
 {
-    debug(20, 1) ("MemObject->data.head: %p\n",
-	mem->data_hdr.head);
-    debug(20, 1) ("MemObject->data.tail: %p\n",
-	mem->data_hdr.tail);
-    debug(20, 1) ("MemObject->data.origin_offset: %d\n",
-	mem->data_hdr.origin_offset);
     debug(20, 1) ("MemObject->start_ping: %d.%06d\n",
 	(int) mem->start_ping.tv_sec,
 	(int) mem->start_ping.tv_usec);
-    debug(20, 1) ("MemObject->inmem_hi: %d\n",
-	(int) mem->inmem_hi);
-    debug(20, 1) ("MemObject->inmem_lo: %d\n",
-	(int) mem->inmem_lo);
-    debug(20, 1) ("MemObject->clients: %p\n",
-	mem->clients);
-    debug(20, 1) ("MemObject->nclients: %d\n",
-	mem->nclients);
     debug(20, 1) ("MemObject->reply: %p\n",
 	mem->reply);
     debug(20, 1) ("MemObject->request: %p\n",
@@ -1090,8 +954,7 @@
 void
 storeEntryDump(const StoreEntry * e, int l)
 {
-    debug(20, l) ("StoreEntry->key: %s\n", storeKeyText(e->hash.key));
-    debug(20, l) ("StoreEntry->next: %p\n", e->hash.next);
+    debug(20, l) ("StoreEntry->key: %s\n", storeKeyUrl(e));
     debug(20, l) ("StoreEntry->mem_obj: %p\n", e->mem_obj);
     debug(20, l) ("StoreEntry->timestamp: %d\n", (int) e->timestamp);
     debug(20, l) ("StoreEntry->lastref: %d\n", (int) e->lastref);
@@ -1109,40 +972,6 @@
     debug(20, l) ("StoreEntry->swap_status: %d\n", (int) e->swap_status);
 }
 
-/*
- * NOTE, this function assumes only two mem states
- */
-void
-storeSetMemStatus(StoreEntry * e, int new_status)
-{
-    MemObject *mem = e->mem_obj;
-    if (new_status == e->mem_status)
-	return;
-    assert(mem != NULL);
-    if (new_status == IN_MEMORY) {
-	assert(mem->inmem_lo == 0);
-	if (EBIT_TEST(e->flags, ENTRY_SPECIAL)) {
-	    debug(20, 4) ("storeSetMemStatus: not inserting special %s into policy\n",
-		mem->url);
-	} else {
-	    mem_policy->Add(mem_policy, e, &mem->repl);
-	    debug(20, 4) ("storeSetMemStatus: inserted mem node %s\n",
-		mem->url);
-	}
-	hot_obj_count++;
-    } else {
-	if (EBIT_TEST(e->flags, ENTRY_SPECIAL)) {
-	    debug(20, 4) ("storeSetMemStatus: special entry %s\n",
-		mem->url);
-	} else {
-	    mem_policy->Remove(mem_policy, e, &mem->repl);
-	    debug(20, 4) ("storeSetMemStatus: removed mem node %s\n",
-		mem->url);
-	}
-	hot_obj_count--;
-    }
-    e->mem_status = new_status;
-}
 
 const char *
 storeUrl(const StoreEntry * e)
@@ -1155,6 +984,13 @@
 	return e->mem_obj->url;
 }
 
+
+const char *
+storeKeyUrl(const StoreEntry *e)
+{
+    return storeUrl(e);
+}
+
 void
 storeCreateMemObject(StoreEntry * e, const char *url, const char *log_url)
 {
@@ -1176,7 +1012,6 @@
 {
     EBIT_CLR(e->flags, DELAY_SENDING);
     InvokeHandlers(e);
-    storeSwapOut(e);
 }
 
 int
@@ -1209,9 +1044,7 @@
 {
     MemObject *mem = e->mem_obj;
     debug(20, 3) ("storeEntryReset: %s\n", storeUrl(e));
-    assert(mem->swapout.sio == NULL);
-    stmemFree(&mem->data_hdr);
-    mem->inmem_hi = mem->inmem_lo = 0;
+    /* XXX hrm, we have to reset the reply object? -- adrian */
     httpReplyDestroy(mem->reply);
     mem->reply = httpReplyCreate();
     e->expires = e->lastmod = e->timestamp = -1;
@@ -1299,7 +1132,24 @@
     debug(20, 1) ("ERROR: Be sure to have set cache_replacement_policy\n");
     debug(20, 1) ("ERROR:   and memory_replacement_policy in squid.conf!\n");
     fatalf("ERROR: Unknown policy %s\n", settings->type);
-    return NULL;		/* NOTREACHED */
+    return NULL; /* NOTREACHED */
+}
+
+/*
+ * Peek into the amount of an object that is in memory
+ */
+off_t
+storeMemHiOffset(const StoreEntry *e)
+{
+    assert(e->mem_obj != NULL);
+    return e->stmemhi(e);
+}
+
+off_t
+storeMemLoOffset(const StoreEntry *e)
+{
+    assert(e->mem_obj != NULL);
+    return e->stmemlo(e);
 }
 
 #if 0
@@ -1320,3 +1170,49 @@
     }
 }
 #endif
+
+
+
+/*
+ * storeDetachReply() - detach a reply from a MemObject
+ */
+void
+storeDetachReply(StoreEntry *e)
+{
+    STRDONE *stdone;
+
+    assert (e != NULL);
+
+    stdone = e->stdone;
+    if (stdone == NULL)
+        return;
+
+    stdone(e);
+
+    e->stappend = NULL;
+    e->stflush = NULL;
+    e->stmemhi = NULL;
+    e->stmemlo = NULL;
+    e->stclientcopy = NULL;
+    e->strelease = NULL;
+    e->stdone = NULL;
+    e->stmakeprivate = NULL;
+    e->stmakepublic = NULL;
+    e->stdata = NULL;
+}
+
+
+/*
+ * double check the request matches what we are after
+ * this should be used *before* calling storeLookup to make sure I
+ * have things 'right'.
+ */
+void
+storeDoubleCheckRequest(request_t *request, char *uri, method_t method)
+{
+    assert(request->method == method);
+    /*
+     * ignore the URI for the time being, as it kinda has to be set
+     */
+    /* assert(strncmp(request->urlpath.buf, uri, request->urlpath.len) == 0); */
+}
